#ifndef BROMSCRIPT_BW_INCLUDED
#define BROMSCRIPT_BW_INCLUDED

#include "SIF.h"

namespace BromScript {
	class ByteWriter
	{
	public:
		int Count;
		byte* Buffer;

		ByteWriter(void);
		~ByteWriter(void);
		
		void WriteBool(bool value);
		void WriteByte(byte value);
		void WriteBytes(byte* value, int size, bool writelen);
		void WriteShort(short value);
		void WriteInt(int value);
		void WriteDouble(double value);
		void WriteString(Scratch::CString value);
		void WriteStrings(List<Scratch::CString> value, bool writelen);
		void WriteStrings(CStackArray<Scratch::CString>& value, bool writelen);
		void Clear();
	private:
		int BufferSize;
		
		void CheckSpace(int needed);
		void AllocateMoreSpace(int addsize);
	};
}

#endif