#ifndef BROMSCRIPT_CONVERTER_INCLUDED
#define BROMSCRIPT_CONVERTER_INCLUDED

#include "SIF.h"
#include "Variable.h"
#include "Table.h"
#include "Misc.h"
#include "MemberData.h"

using namespace Scratch;

namespace BromScript{
	class Converter{
	public:
		static Variable* ToVariable(bool value);
		static Variable* ToVariable(double value);
		static Variable* ToVariable(int value);
		static Variable* ToVariable(float value);
		static Variable* ToVariable(char* value);
		static Variable* ToVariable(Scratch::CString value);
		static Variable* ToVariable(Table* value);
		static Variable* ToVariable(Instance* bromscript, const char* key, BSFunction value);
		static Variable* ToVariable(Instance* bromscript, Scratch::CString key, BSFunction value);
		
		static bool SetMember(Variable* member, Variable* value, Scratch::CString key);
		static Variable* MemberToVariable(Instance* bromscript, Variable* member);

		static void* NumberToPointer(double val);
		static void* BoolToPointer(bool val);
		static void* StringToPointer(Scratch::CString val);
		
		static Scratch::CString TypeToString(Variable::VariableType type);
		static Scratch::CString TypeToString(Instance* bromscript, Variable::VariableType type);
		static Scratch::CString Converter::ArithmaticToString(Misc::ArithmaticFuncs type);
	};
}

#endif