#ifndef BROMSCRIPT_EXECUTER_INCLUDED
#define BROMSCRIPT_EXECUTER_INCLUDED

#include "Variable.h"
#include "ExecuteData.h"
#include "Misc.h"

namespace BromScript {
	class Executer
	{
	public:
		static void SetVar(ExecuteData* data);
		static void LSetVar(ExecuteData* data);
		static void SetTableIndex(ExecuteData* data);

		static void CreateFunction(ExecuteData* data);
		static void If(ExecuteData* data);
		static void Else(ExecuteData* data);

		static void While(ExecuteData* data);
		static void For(ExecuteData* data);
		static void ForEach(ExecuteData* data);

		static void CreateClass(ExecuteData* data);

		static Variable* Arithmatic(ExecuteData* data, Variable* vara, Variable* varb, Misc::ArithmaticFuncs func);
		
		static Variable* GetVar(ExecuteData* data);
		static Variable* GetTableIndex(ExecuteData* data);

		static Variable* New(ExecuteData* data);
		static Variable* ExecuteFunction(ExecuteData* data);
		static Variable* Merge(ExecuteData* data);
		static Variable* Return(ExecuteData* data);

		static Variable* GetBool(ExecuteData* data);
		static Variable* GetTable(ExecuteData* data);
		static Variable* GetString(ExecuteData* data);
		static Variable* GetNumber(ExecuteData* data);
	};
}

#endif