#ifndef BROMSCRIPT_FUNCTION_INCLUDED
#define BROMSCRIPT_FUNCTION_INCLUDED

#include "SIF.h"

#include "Misc.h"
#include "Instance.h"
#include "Variable.h"
#include "ExecuteData.h"
#include "Executer.h"
#include "ArgumentData.h"
#include "Table.h"

namespace BromScript {
	class Function
	{
	public:
		static int GetCount();

		Function(Instance* bromscript);
		~Function();
		
		Variable* Run();
		Variable* Run(Variable* thisobject);
		Variable* Run(ArgumentData* args);
		Variable* Run(ArgumentData* args, Variable* thisobject);
		Variable* Run(List<Variable*>* args);
		Variable* Run(List<Variable*>* args, Variable* thisobject);
		Variable* InternalRun(ExecuteData* data);
		
		void SetVar(Scratch::CString key, Variable* var, bool global);
		Variable* GetVar(Scratch::CString var);

		Instance* BromScript;
		Function* Parent;
		Table* Locals;
		List<Scratch::CString> Parameters;

		Scratch::CString Name;
		Scratch::CString Filename;
		byte* Code;

		bool ForceReturn;
		bool IsCpp;
		BSFunction CppFunc;
		Variable* CurrentThisObject;

	private:
	};
}

#endif