#ifndef BROMSCRIPT_TABLE_INCLUDED
#define BROMSCRIPT_TABLE_INCLUDED

#include "SIF.h"
#include "Instance.h"
#include "Variable.h"

namespace BromScript{
	class Table
	{
	public:
		static int GetCount();

		Table(Instance* bromscript);
		~Table();

		Instance* BromScript;
		void Set(Scratch::CString key, Variable* var);
		Variable* Get(Scratch::CString key);
		Variable* GetByIndex(int index);
		CString GetKeyByIndex(int index);
		bool HasKey(Scratch::CString key);

		int Count;
		
		void Remove(Scratch::CString key);
		void Clear();
		
		Variable* operator[](Scratch::CString key);
	private:
		CString** Keys;
		Variable** Values;
		int BufferSize;

		void AllocateMoreSpace();
	};
}

#endif